<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Controller\Adminhtml\Schedule;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\ScheduleInterface;

class Edit extends Adminhtml\Action
{
    const ADMIN_RESOURCE = 'Neklo_Scheduler::edit';
    /**
     * Redirect url
     */
    const REDIRECT_URL = '*/schedule/index';
    const MODEL_REGISTRY = 'edit_schedule';

    public function execute()
    {
        $ret = $this->setupModel();
        if ($ret !== false) {
            return $ret;
        }

        $resultPage = $this->resultPageFactory->create();
        $this->_initAction($resultPage);
        $resultPage->addBreadcrumb(
            __('Edit Schedule'),
            __('Edit Schedule')
        );
        $resultPage->getConfig()->getTitle()->prepend(__('Cron Scheduler'));
        return $resultPage;
    }

    private function setupModel()
    {
        $id = $this->getRequest()->getParam(ScheduleInterface::SCHEDULE_ID);
        $model = $this->_objectManager->create('Magento\Cron\Model\Schedule');

        if ($id) {
            $model->load($id);
            if (empty($model->getData())) {
                $this->messageManager->addError(__('This scheduled job no longer exists.'));
                return $this->_redirect(static::REDIRECT_URL);
            } else {
                // 3. Set entered data if was error when we do save
                $data = $this->_objectManager
                    ->get('Magento\Backend\Model\Session')
                    ->getFormData(true);
                if (!empty($data)) {
                    $model->setData($data);
                }

                // 4. Register model to use later in blocks
                $this->coreRegistry->register(static::MODEL_REGISTRY, $model);
            }
        } else {
            return $this->_redirect(static::REDIRECT_URL);
        }

        return false;
    }
}
