<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Helper;

use Magento\Store\Model\Store;
use Magento\Framework\App\Helper\Context;
use Magento\Store\Model\StoreManagerInterface;

class Config extends \Magento\Framework\App\Helper\AbstractHelper
{
    //const GENERAL_ENABLED = 'neklo_scheduler/general/is_enabled';
    //const GENERAL_MAX_JOB_RUNTIME = 'neklo_scheduler/general/max_job_runtime';
    //const GENERAL_SCHEDULE = 'neklo_scheduler/general/scheduler_cron_expr_heartbeat';
    //const GENERAL_MAX_TASKS = 'neklo_scheduler/general/maxNoOfSuccessfulTasks';

    //const ERROR_ENABLE_LOG = 'neklo_scheduler/error/enable_log';
    //const ERROR_MARK_AS_ERROR = 'neklo_scheduler/error/mark_as_error_after';
    const ERROR_EMAIL = 'neklo_scheduler/error/email';
    const ERROR_EMAIL_SENDER = 'neklo_scheduler/error/email_identity';
    const ERROR_EMAIL_TEMPLATE = 'neklo_scheduler/error/email_template';

    //const LOG_OUTPUT_BUFFER = 'neklo_scheduler/log/enable_job_output_buffer';

    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    private $storeManager;

    /**
     * @var \Magento\Store\Model\Store
     */
    private $store;

    public function __construct(
        Context $context,
        StoreManagerInterface $storeManager
    ) {
        parent::__construct($context);
        $this->storeManager = $storeManager;
    }

    /**
     * Set current store
     *
     * @param  Store $store
     *
     * @return void
     */
    public function setStore(Store $store)
    {
        $this->store = $store;
    }

    /**
     * Return store
     *
     * @return Store
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function getStore()
    {
        //current store
        if (!$this->store instanceof Store) {
            $this->setStore($this->storeManager->getStore());
        }

        return $this->store;
    }

    /**
     *
     * @param string $path
     * @param int $store
     *
     * @return string
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function getConfigValue($path, $store = null)
    {
        return $this->scopeConfig->getValue(
            $path,
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE,
            $store ? $store : $this->getStore()->getStoreId()
        );
    }

    // TODO: TO REMOVE BECAUSE IN NOT USED ANYWHERE
    /*public function isEnabled($store = null)
    {
        return $this->getConfigValue(self::GENERAL_ENABLED, $store) != "disabled";
    }

    public function getMaxJobRuntime($store = null)
    {
        return $this->getConfigValue(self::GENERAL_MAX_JOB_RUNTIME, $store);
    }

    // TODO: TO REMOVE BECAUSE IN NOT USED ANYWHERE
    public function isCronExpr($store = null)
    {
        return $this->getConfigValue(self::GENERAL_SCHEDULE, $store);
    }

    public function getMaxNoOfSuccessfulTasks($store = null)
    {
        return $this->getConfigValue(self::GENERAL_MAX_TASKS, $store);
    }

    public function isEnabledJobOutputBuffer($store = null)
    {
        return $this->getConfigValue(self::LOG_OUTPUT_BUFFER, $store);
    }

    public function isEnabledErrorLog($store = null)
    {
        return $this->getConfigValue(self::ERROR_ENABLE_LOG, $store);
    }
    */

    public function getEmailRecipient($store = null)
    {
        return $this->getConfigValue(self::ERROR_EMAIL, $store);
    }

    public function getEmailSender($store = null)
    {
        return $this->getConfigValue(self::ERROR_EMAIL_SENDER, $store);
    }

    public function getEmailTemplate($store = null)
    {
        return $this->getConfigValue(self::ERROR_EMAIL_TEMPLATE, $store);
    }


}
