<?php

namespace Neklo\Scheduler\Model;

use Magento\Cron\Model\Config\Data;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\App\ResourceConnection;

/**
 * Class Config
 * @package Neklo\Scheduler\Model
 */
class Config extends \Magento\Cron\Model\Config
{

    /**
     * @var JobFactory
     */
    private $jobFactory;
    /**
     * @var ResourceConnection|mixed
     */
    private $resourceConnection;

    /**
     * Config constructor.
     * @param Data $configData
     * @param JobFactory $jobFactory
     */
    public function __construct(
        Data       $configData,
        JobFactory $jobFactory
    ) {
        parent::__construct($configData);
        $this->jobFactory = $jobFactory;
        $objectManager = ObjectManager::getInstance();
        $this->resourceConnection = $objectManager->create('Magento\Framework\App\ResourceConnection');
    }

    /**
     * @return array
     */
    public function getJobs()
    {
        $jobs = parent::getJobs();

        /*$coll = $this->jobFactory->create()->getCollection();
        $coll->addFieldToFilter('enabled', true);

        foreach ($coll->getItems() as $item) {
            $jobs[$item->getGroup()][$item->getName()] = $item->getData();
        }*/

        // Instance of object manager
        $connection = $this->resourceConnection->getConnection();
        $nekloCronTable = $connection->getTableName('neklo_cron');
        $cronJobs = $connection->fetchAll("SELECT * FROM {$nekloCronTable} WHERE enabled = 1");

        foreach ($cronJobs as $item) {
            $jobs[$item['group']][$item['name']] = $item;
        }

        return $jobs;
    }
}
