<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Model\Source\Schedule;

use Magento\Cron\Model\ResourceModel\Schedule\CollectionFactory;

class JobCode implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var CollectionFactory
     */
    private $collectionFactory;

    /**
     *
     * @param CollectionFactory $collection
     */
    public function __construct(CollectionFactory $collection)
    {
        $this->collectionFactory = $collection;
    }

    public function toOptionArray()
    {
        $collection = $this->collectionFactory->create();
        $collection->getSelect()
            ->reset(\Zend_Db_Select::COLUMNS)
            ->columns('job_code')
            ->group(['job_code']);

        $items = [];
        foreach ($collection->getItems() as $code) {
            $items[] = $this->getOption($code['job_code']);
        }

        return $items;
    }

    protected function getOption($code)
    {
        return ['value' => $code, 'label' => $code];
    }
}
