<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Setup;

use Magento\Eav\Setup\EavSetupFactory;
use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Neklo\Scheduler\Api\Data\JobInterface;

/**
 * @codeCoverageIgnore
 */
class InstallData implements InstallDataInterface
{
    /**
     * {@inheritdoc}
     */
    public function install(
        ModuleDataSetupInterface $setup,
        ModuleContextInterface $context
    ) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $jf = $objectManager->create('\Neklo\Scheduler\Model\JobFactory');
        $jobs = $objectManager->create('\Neklo\Scheduler\Helper\Job')->getJobs();
        if (is_array($jobs)) {
            foreach ($jobs as $group => $groupJobs) {
                foreach ($groupJobs as $jobName => $job) {
                    $item = $jf->create();
                    $item->load($jobName, JobInterface::JOB_NAME);
                    $item->setName($jobName)
                        ->setMethod($job[JobInterface::JOB_METHOD])
                        ->setInstance($job[JobInterface::JOB_CLASS])
                        ->setEnabled(false)
                        ->setGroup($group);
                    if (isset($job[JobInterface::JOB_SCHEDULE])) {
                        $item->setSchedule($job[JobInterface::JOB_SCHEDULE]);
                    }

                    if (isset($job[JobInterface::JOB_CONFIG])) {
                        $item->setConfigPath($job[JobInterface::JOB_CONFIG]);
                    }

                    $item->save();
                }
            }
        }
    }
}
